//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3E89C5BD024C.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3E89C5BD024C.cm

//## begin module%3E89C5BD024C.cp preserve=no
//## end module%3E89C5BD024C.cp

//## Module: FakeDataInputRecord%3E89C5BD024C; Package specification
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/FakeDataInputRecord.h

#ifndef FAKEDATAINPUTRECORD_H
#define FAKEDATAINPUTRECORD_H 1

//## begin module%3E89C5BD024C.additionalIncludes preserve=no
//## end module%3E89C5BD024C.additionalIncludes

//## begin module%3E89C5BD024C.includes preserve=yes
//## end module%3E89C5BD024C.includes

// utility
#include <utility>
// xsTypes
#include <main/xsTypes.h>
// DataInputRecord
#include <XSModel/Data/DataInputRecord.h>
//## begin module%3E89C5BD024C.declarations preserve=no
//## end module%3E89C5BD024C.declarations

//## begin module%3E89C5BD024C.additionalDeclarations preserve=yes
//## end module%3E89C5BD024C.additionalDeclarations


//## begin FakeDataInputRecord%3E89C781030C.preface preserve=yes
//## end FakeDataInputRecord%3E89C781030C.preface

//## Class: FakeDataInputRecord%3E89C781030C
//## Category: XSModel::Data%36349D4100F3
//## Subsystem: XSModel::Data%367691B49E40
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class FakeDataInputRecord : public DataInputRecord  //## Inherits: <unnamed>%3E89C8750391
{
  //## begin FakeDataInputRecord%3E89C781030C.initialDeclarations preserve=yes
  //## end FakeDataInputRecord%3E89C781030C.initialDeclarations

  public:
    //## Class: BackLocator%41B5E11B03E3
    //	Location of Back/Corr spectra given by <fileName,rowNum>
    //	where rowNum = 0 for type I file.
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::pair<string,size_t> BackLocator;

    //## Class: ResponseID%47C431AC0372
    //	Stores the response file name and its 0-based sourceNum
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::pair<string,size_t> ResponseID;

    //## Class: Detectors%47C432710397
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::vector<ResponseID> Detectors;

    //## Class: ArfID%47C433C10076
    //	The BackLocator member stores Arf <fileName,rowNum> and
    //	the size_t member stores 0-based sourceNum.
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::pair<BackLocator,size_t> ArfID;

    //## Class: Arfs%47C434A101FD
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::vector<ArfID> Arfs;

    //## Constructors (specified)
      //## Operation: FakeDataInputRecord%3E95DDF200C1
      FakeDataInputRecord (size_t nSpec);

    //## Destructor (generated)
      ~FakeDataInputRecord();


    //## Other Operations (specified)
      //## Operation: printDiagnostics%3EC538C10397
      void printDiagnostics () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: backgndFile%3E89D4920315
      const string& backgndFile () const;
      void backgndFile (const string& value);

      //## Attribute: useCountingStat%3E89D582015F
      bool useCountingStat () const;
      void useCountingStat (bool value);

      //## Attribute: isType2%3E8A040D0260
      bool isType2 () const;
      void isType2 (bool value);

      //## Attribute: exposureTime%3EC504D4018E
      Real exposureTime () const;
      void exposureTime (Real value);

      //## Attribute: correctionNorm%3EC5050C034F
      Real correctionNorm () const;
      void correctionNorm (Real value);

      //## Attribute: enteredNone%41B5E0140019
      bool enteredNone () const;
      void enteredNone (bool value);

      //## Attribute: numSourcesForSpectra%47C5A26102E8
      //	This is the total number of possible sources for the fake
      //	spectra to be created.  It is optional that they later
      //	be filled in with actual responses.
      size_t numSourcesForSpectra () const;
      void numSourcesForSpectra (size_t value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::<unnamed>%3EB826A8019F
      //## Role: FakeDataInputRecord::origRowNums%3EB826AA02D4
      //## Qualifier: index%3EB827510199; size_t
      const IntegerArray& origRowNums () const;
      void setOrigRowNums (const IntegerArray& value);
      int origRowNums (size_t index) const;
      void origRowNums (size_t index, int value);

      //## Association: XSModel::Data::<unnamed>%41B5E234010F
      //## Role: FakeDataInputRecord::inputCorrFiles%41B5E2380121
      //## Qualifier: index%41B5E28B0084; size_t
      const std::vector<BackLocator>& inputCorrFiles () const;
      void setInputCorrFiles (const std::vector<BackLocator>& value);
      const BackLocator& inputCorrFiles (size_t index) const;
      void inputCorrFiles (size_t index, const BackLocator& value);

      //## Association: XSModel::Data::<unnamed>%41B5E3A8007F
      //## Role: FakeDataInputRecord::inputBackgrounds%41B5E3A901DB
      //## Qualifier: index%41B5E3FE03D3; size_t
      const std::vector<BackLocator>& inputBackgrounds () const;
      void setInputBackgrounds (const std::vector<BackLocator>& value);
      const BackLocator& inputBackgrounds (size_t index) const;
      void inputBackgrounds (size_t index, const BackLocator& value);

      //## Association: XSModel::Data::<unnamed>%47C439DC031C
      //## Role: FakeDataInputRecord::inputResponses%47C439DD037E
      //## Qualifier: index%47C43A4C0275; size_t
      const std::vector<Detectors>& inputResponses () const;
      void setInputResponses (const std::vector<Detectors>& value);
      const Detectors& inputResponses (size_t index) const;
      void inputResponses (size_t index, const Detectors& value);

      //## Association: XSModel::Data::<unnamed>%47C43BBF005D
      //## Role: FakeDataInputRecord::inputArfs%47C43BC0013A
      //## Qualifier: index%47C43BF200DB; size_t
      const std::vector<Arfs>& inputArfs () const;
      void setInputArfs (const std::vector<Arfs>& value);
      const Arfs& inputArfs (size_t index) const;
      void inputArfs (size_t index, const Arfs& value);

  public:
    // Additional Public Declarations
      //## begin FakeDataInputRecord%3E89C781030C.public preserve=yes
      //## end FakeDataInputRecord%3E89C781030C.public

  protected:
    // Additional Protected Declarations
      //## begin FakeDataInputRecord%3E89C781030C.protected preserve=yes
      //## end FakeDataInputRecord%3E89C781030C.protected

  private:
    // Additional Private Declarations
      //## begin FakeDataInputRecord%3E89C781030C.private preserve=yes
      //## end FakeDataInputRecord%3E89C781030C.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin FakeDataInputRecord::backgndFile%3E89D4920315.attr preserve=no  public: string {U} 
      string m_backgndFile;
      //## end FakeDataInputRecord::backgndFile%3E89D4920315.attr

      //## begin FakeDataInputRecord::useCountingStat%3E89D582015F.attr preserve=no  public: bool {U} 
      bool m_useCountingStat;
      //## end FakeDataInputRecord::useCountingStat%3E89D582015F.attr

      //## begin FakeDataInputRecord::isType2%3E8A040D0260.attr preserve=no  public: bool {U} 
      bool m_isType2;
      //## end FakeDataInputRecord::isType2%3E8A040D0260.attr

      //## begin FakeDataInputRecord::exposureTime%3EC504D4018E.attr preserve=no  public: Real {U} 
      Real m_exposureTime;
      //## end FakeDataInputRecord::exposureTime%3EC504D4018E.attr

      //## begin FakeDataInputRecord::correctionNorm%3EC5050C034F.attr preserve=no  public: Real {U} 
      Real m_correctionNorm;
      //## end FakeDataInputRecord::correctionNorm%3EC5050C034F.attr

      //## begin FakeDataInputRecord::enteredNone%41B5E0140019.attr preserve=no  public: bool {U} 
      bool m_enteredNone;
      //## end FakeDataInputRecord::enteredNone%41B5E0140019.attr

      //## begin FakeDataInputRecord::numSourcesForSpectra%47C5A26102E8.attr preserve=no  public: size_t {U} 
      size_t m_numSourcesForSpectra;
      //## end FakeDataInputRecord::numSourcesForSpectra%47C5A26102E8.attr

    // Data Members for Associations

      //## Association: XSModel::Data::<unnamed>%3EB826A8019F
      //## begin FakeDataInputRecord::origRowNums%3EB826AA02D4.role preserve=no  public: IntegerArray { -> 1VHgN}
      IntegerArray m_origRowNums;
      //## end FakeDataInputRecord::origRowNums%3EB826AA02D4.role

      //## Association: XSModel::Data::<unnamed>%41B5E234010F
      //## begin FakeDataInputRecord::inputCorrFiles%41B5E2380121.role preserve=no  public: FakeDataInputRecord::BackLocator {1 -> 1..nVHgN}
      std::vector<BackLocator> m_inputCorrFiles;
      //## end FakeDataInputRecord::inputCorrFiles%41B5E2380121.role

      //## Association: XSModel::Data::<unnamed>%41B5E3A8007F
      //## begin FakeDataInputRecord::inputBackgrounds%41B5E3A901DB.role preserve=no  public: FakeDataInputRecord::BackLocator {1 -> 1..nVHgN}
      std::vector<BackLocator> m_inputBackgrounds;
      //## end FakeDataInputRecord::inputBackgrounds%41B5E3A901DB.role

      //## Association: XSModel::Data::<unnamed>%47C439DC031C
      //## begin FakeDataInputRecord::inputResponses%47C439DD037E.role preserve=no  public: FakeDataInputRecord::Detectors {1 -> 1..nVHgN}
      std::vector<Detectors> m_inputResponses;
      //## end FakeDataInputRecord::inputResponses%47C439DD037E.role

      //## Association: XSModel::Data::<unnamed>%47C43BBF005D
      //## begin FakeDataInputRecord::inputArfs%47C43BC0013A.role preserve=no  public: FakeDataInputRecord::Arfs {1 -> 1..nVHgN}
      std::vector<Arfs> m_inputArfs;
      //## end FakeDataInputRecord::inputArfs%47C43BC0013A.role

    // Additional Implementation Declarations
      //## begin FakeDataInputRecord%3E89C781030C.implementation preserve=yes
      //## end FakeDataInputRecord%3E89C781030C.implementation

};

//## begin FakeDataInputRecord%3E89C781030C.postscript preserve=yes
//## end FakeDataInputRecord%3E89C781030C.postscript

// Class FakeDataInputRecord 

//## Get and Set Operations for Class Attributes (inline)

inline const string& FakeDataInputRecord::backgndFile () const
{
  //## begin FakeDataInputRecord::backgndFile%3E89D4920315.get preserve=no
  return m_backgndFile;
  //## end FakeDataInputRecord::backgndFile%3E89D4920315.get
}

inline void FakeDataInputRecord::backgndFile (const string& value)
{
  //## begin FakeDataInputRecord::backgndFile%3E89D4920315.set preserve=no
  m_backgndFile = value;
  //## end FakeDataInputRecord::backgndFile%3E89D4920315.set
}

inline bool FakeDataInputRecord::useCountingStat () const
{
  //## begin FakeDataInputRecord::useCountingStat%3E89D582015F.get preserve=no
  return m_useCountingStat;
  //## end FakeDataInputRecord::useCountingStat%3E89D582015F.get
}

inline void FakeDataInputRecord::useCountingStat (bool value)
{
  //## begin FakeDataInputRecord::useCountingStat%3E89D582015F.set preserve=no
  m_useCountingStat = value;
  //## end FakeDataInputRecord::useCountingStat%3E89D582015F.set
}

inline bool FakeDataInputRecord::isType2 () const
{
  //## begin FakeDataInputRecord::isType2%3E8A040D0260.get preserve=no
  return m_isType2;
  //## end FakeDataInputRecord::isType2%3E8A040D0260.get
}

inline void FakeDataInputRecord::isType2 (bool value)
{
  //## begin FakeDataInputRecord::isType2%3E8A040D0260.set preserve=no
  m_isType2 = value;
  //## end FakeDataInputRecord::isType2%3E8A040D0260.set
}

inline Real FakeDataInputRecord::exposureTime () const
{
  //## begin FakeDataInputRecord::exposureTime%3EC504D4018E.get preserve=no
  return m_exposureTime;
  //## end FakeDataInputRecord::exposureTime%3EC504D4018E.get
}

inline void FakeDataInputRecord::exposureTime (Real value)
{
  //## begin FakeDataInputRecord::exposureTime%3EC504D4018E.set preserve=no
  m_exposureTime = value;
  //## end FakeDataInputRecord::exposureTime%3EC504D4018E.set
}

inline Real FakeDataInputRecord::correctionNorm () const
{
  //## begin FakeDataInputRecord::correctionNorm%3EC5050C034F.get preserve=no
  return m_correctionNorm;
  //## end FakeDataInputRecord::correctionNorm%3EC5050C034F.get
}

inline void FakeDataInputRecord::correctionNorm (Real value)
{
  //## begin FakeDataInputRecord::correctionNorm%3EC5050C034F.set preserve=no
  m_correctionNorm = value;
  //## end FakeDataInputRecord::correctionNorm%3EC5050C034F.set
}

inline bool FakeDataInputRecord::enteredNone () const
{
  //## begin FakeDataInputRecord::enteredNone%41B5E0140019.get preserve=no
  return m_enteredNone;
  //## end FakeDataInputRecord::enteredNone%41B5E0140019.get
}

inline void FakeDataInputRecord::enteredNone (bool value)
{
  //## begin FakeDataInputRecord::enteredNone%41B5E0140019.set preserve=no
  m_enteredNone = value;
  //## end FakeDataInputRecord::enteredNone%41B5E0140019.set
}

inline size_t FakeDataInputRecord::numSourcesForSpectra () const
{
  //## begin FakeDataInputRecord::numSourcesForSpectra%47C5A26102E8.get preserve=no
  return m_numSourcesForSpectra;
  //## end FakeDataInputRecord::numSourcesForSpectra%47C5A26102E8.get
}

inline void FakeDataInputRecord::numSourcesForSpectra (size_t value)
{
  //## begin FakeDataInputRecord::numSourcesForSpectra%47C5A26102E8.set preserve=no
  m_numSourcesForSpectra = value;
  //## end FakeDataInputRecord::numSourcesForSpectra%47C5A26102E8.set
}

//## Get and Set Operations for Associations (inline)

inline const IntegerArray& FakeDataInputRecord::origRowNums () const
{
  //## begin FakeDataInputRecord::origRowNums%3EB826AA02D4.get preserve=no
  return m_origRowNums;
  //## end FakeDataInputRecord::origRowNums%3EB826AA02D4.get
}

inline void FakeDataInputRecord::setOrigRowNums (const IntegerArray& value)
{
  //## begin FakeDataInputRecord::setOrigRowNums%3EB826AA02D4.set preserve=no
  m_origRowNums = value;
  //## end FakeDataInputRecord::setOrigRowNums%3EB826AA02D4.set
}

inline int FakeDataInputRecord::origRowNums (size_t index) const
{
  //## begin FakeDataInputRecord::origRowNums%3EB826AA02D4.qualget preserve=no
  return m_origRowNums[index];
  //## end FakeDataInputRecord::origRowNums%3EB826AA02D4.qualget
}

inline void FakeDataInputRecord::origRowNums (size_t index, int value)
{
  //## begin FakeDataInputRecord::origRowNums%3EB826AA02D4.qualset preserve=no
  m_origRowNums[index] = value;
  //## end FakeDataInputRecord::origRowNums%3EB826AA02D4.qualset
}

inline const std::vector<FakeDataInputRecord::BackLocator>& FakeDataInputRecord::inputCorrFiles () const
{
  //## begin FakeDataInputRecord::inputCorrFiles%41B5E2380121.get preserve=no
  return m_inputCorrFiles;
  //## end FakeDataInputRecord::inputCorrFiles%41B5E2380121.get
}

inline void FakeDataInputRecord::setInputCorrFiles (const std::vector<FakeDataInputRecord::BackLocator>& value)
{
  //## begin FakeDataInputRecord::setInputCorrFiles%41B5E2380121.set preserve=no
  m_inputCorrFiles = value;
  //## end FakeDataInputRecord::setInputCorrFiles%41B5E2380121.set
}

inline const FakeDataInputRecord::BackLocator& FakeDataInputRecord::inputCorrFiles (size_t index) const
{
  //## begin FakeDataInputRecord::inputCorrFiles%41B5E2380121.qualget preserve=no
  return m_inputCorrFiles[index];
  //## end FakeDataInputRecord::inputCorrFiles%41B5E2380121.qualget
}

inline void FakeDataInputRecord::inputCorrFiles (size_t index, const FakeDataInputRecord::BackLocator& value)
{
  //## begin FakeDataInputRecord::inputCorrFiles%41B5E2380121.qualset preserve=no
  m_inputCorrFiles[index] = value;
  //## end FakeDataInputRecord::inputCorrFiles%41B5E2380121.qualset
}

inline const std::vector<FakeDataInputRecord::BackLocator>& FakeDataInputRecord::inputBackgrounds () const
{
  //## begin FakeDataInputRecord::inputBackgrounds%41B5E3A901DB.get preserve=no
  return m_inputBackgrounds;
  //## end FakeDataInputRecord::inputBackgrounds%41B5E3A901DB.get
}

inline void FakeDataInputRecord::setInputBackgrounds (const std::vector<FakeDataInputRecord::BackLocator>& value)
{
  //## begin FakeDataInputRecord::setInputBackgrounds%41B5E3A901DB.set preserve=no
  m_inputBackgrounds = value;
  //## end FakeDataInputRecord::setInputBackgrounds%41B5E3A901DB.set
}

inline const FakeDataInputRecord::BackLocator& FakeDataInputRecord::inputBackgrounds (size_t index) const
{
  //## begin FakeDataInputRecord::inputBackgrounds%41B5E3A901DB.qualget preserve=no
  return m_inputBackgrounds[index];
  //## end FakeDataInputRecord::inputBackgrounds%41B5E3A901DB.qualget
}

inline void FakeDataInputRecord::inputBackgrounds (size_t index, const FakeDataInputRecord::BackLocator& value)
{
  //## begin FakeDataInputRecord::inputBackgrounds%41B5E3A901DB.qualset preserve=no
  m_inputBackgrounds[index] = value;
  //## end FakeDataInputRecord::inputBackgrounds%41B5E3A901DB.qualset
}

inline const std::vector<FakeDataInputRecord::Detectors>& FakeDataInputRecord::inputResponses () const
{
  //## begin FakeDataInputRecord::inputResponses%47C439DD037E.get preserve=no
  return m_inputResponses;
  //## end FakeDataInputRecord::inputResponses%47C439DD037E.get
}

inline void FakeDataInputRecord::setInputResponses (const std::vector<FakeDataInputRecord::Detectors>& value)
{
  //## begin FakeDataInputRecord::setInputResponses%47C439DD037E.set preserve=no
  m_inputResponses = value;
  //## end FakeDataInputRecord::setInputResponses%47C439DD037E.set
}

inline const FakeDataInputRecord::Detectors& FakeDataInputRecord::inputResponses (size_t index) const
{
  //## begin FakeDataInputRecord::inputResponses%47C439DD037E.qualget preserve=no
  return m_inputResponses[index];
  //## end FakeDataInputRecord::inputResponses%47C439DD037E.qualget
}

inline void FakeDataInputRecord::inputResponses (size_t index, const FakeDataInputRecord::Detectors& value)
{
  //## begin FakeDataInputRecord::inputResponses%47C439DD037E.qualset preserve=no
  m_inputResponses[index] = value;
  //## end FakeDataInputRecord::inputResponses%47C439DD037E.qualset
}

inline const std::vector<FakeDataInputRecord::Arfs>& FakeDataInputRecord::inputArfs () const
{
  //## begin FakeDataInputRecord::inputArfs%47C43BC0013A.get preserve=no
  return m_inputArfs;
  //## end FakeDataInputRecord::inputArfs%47C43BC0013A.get
}

inline void FakeDataInputRecord::setInputArfs (const std::vector<FakeDataInputRecord::Arfs>& value)
{
  //## begin FakeDataInputRecord::setInputArfs%47C43BC0013A.set preserve=no
  m_inputArfs = value;
  //## end FakeDataInputRecord::setInputArfs%47C43BC0013A.set
}

inline const FakeDataInputRecord::Arfs& FakeDataInputRecord::inputArfs (size_t index) const
{
  //## begin FakeDataInputRecord::inputArfs%47C43BC0013A.qualget preserve=no
  return m_inputArfs[index];
  //## end FakeDataInputRecord::inputArfs%47C43BC0013A.qualget
}

inline void FakeDataInputRecord::inputArfs (size_t index, const FakeDataInputRecord::Arfs& value)
{
  //## begin FakeDataInputRecord::inputArfs%47C43BC0013A.qualset preserve=no
  m_inputArfs[index] = value;
  //## end FakeDataInputRecord::inputArfs%47C43BC0013A.qualset
}

//## begin module%3E89C5BD024C.epilog preserve=yes
//## end module%3E89C5BD024C.epilog


#endif
